import Vue from 'vue'
import {
		mobile
	} from '../rulesConfig.js'
var mixin = {
	data() {
		return {
           
		}
	},
	 //#ifdef MP-WEIXIN
	    onShareAppMessage () {
	        return {
	            title: '金融人的数字能力补给站',
	            path: '/pages/index/index',
	            imageUrl: 'https://dcdgroup-static.oss-cn-beijing.aliyuncs.com/%E9%9D%99%E6%80%81%E8%B5%84%E6%BA%90/%E6%B5%8B%E4%B8%80%E6%B5%8B%E9%87%91%E8%9E%8D%E6%95%B0%E5%95%86.png',
	            content: '金融人的数字能力补给站',
	            desc: '金融人的数字能力补给站',
	            success: res => {
	                console.info(res)
	            }
	        }
	    },
	    //#endif
	onReady() {
		
	},
	methods: {
		// 显示loading
		showLoading(title = '加载中') {
			uni.showLoading({
				title,
				mask:true
			});
		},
		// 隐藏loading
		hideLoading() {
			uni.hideLoading();
		},
		// 获取验证码
		getCode(phone,type) {
			if (phone == '') {
				uni.showToast({
					title: '请输入手机号',
					icon: 'none'
				})
				return false
			}
			if (!(mobile.test(phone))) {
				uni.showToast({
					title: '手机号输入有误，请重新输入',
					icon: 'none'
				})
				return false
			}
			this.countDown(60)
			this.$api.getCode({
				phoneNo: phone,
				type
			}).then(res => {
				this.loginError = 'error'
				if(res.resp!='00'){
					uni.showToast({
						title:res.msg,
						icon:'none'
					})
				}
			}).catch(error=>{
				
			})
		},
		countDown(t) {
			if (t > 1) {
				t--
				this.stopTime = t
				setTimeout(() => {
					this.countDown(t)
				}, 1000)
			} else {
				this.stopTime = 60
			}
		}, 
	    //未登录回到登录页
		rebackLogin(url,title,prevUrl){
			return new Promise((resolve,reject)=>{
				if(uni.getStorageSync('token')){
					resolve()
				}else{
					if(title){
						uni.showModal({
						    content: title,
							cancelText:'暂不登录',
							cancelColor:'#999999',
							confirmText:'确认登录',
							confirmColor:'#FE8D1B',
						    success: function (res) {
						        if (res.confirm) {
						            if(url&&prevUrl){
										uni.navigateTo({
											url:url+'?url='+encodeURIComponent(prevUrl)
										})
									}else{
										uni.navigateTo({
											url
										})
									}
						        } 
						    }
						});
					}else{
						if(prevUrl){
							uni.navigateTo({
								url:url+'?url='+encodeURIComponent(prevUrl)
							})
						}else{
							uni.navigateTo({
								url:url
							})
						}
						
					}
					
				}
			})
		},
	    //直接跳转
		go(url){
	    	uni.navigateTo({
	    		url
	    	})
	    },
		//需要判断是否登录 跳转
	    goTo(url, title) {
	    	this.rebackLogin('/page_class/login/index?url='+encodeURIComponent(url), title).then(() => {
	    		uni.navigateTo({
	    			url
	    		})
	    	})
	    },
		// 获取用户信息
		getInfo() {
		    let that = this;
		    return new Promise((resolve,reject)=>{
				that.$api.getInfo().then(res => {
				    if (res.resp === '00') {
				        that.info = res.data
				        uni.setStorage({
				            key: 'info',
				            data: res.data,
							success() {
								resolve()
							}
				        })
				    }
				})
			})
		},
	}
}
export default mixin;
