import Vue from 'vue';
import jsencrypt from '@/js_sdk/jsencrypt-Rsa/jsencrypt/jsencrypt.vue';
import md5 from './md5.js';
import {
	hmacKeyA
} from './rsa.js';
import configData from './config.js';
import utils from './m4/sm4.js';
import apiUrl from './http.js'
let sm4Fun = new utils();

uni.setStorageSync('url', apiUrl);

//获取忽略加密的url
var mode;
var getMode = function() {
	return new Promise((resolve, reject) => {
		uni.request({
			method: 'POST',
			url: apiUrl + 'user/stdLoginMode',
			header: {
				'content-type': 'application/json'
			},
			success: (res) => {
				mode = res.data.data
				uni.setStorageSync('mode', mode);
				resolve()
			},
			fail(error) {
				mode = false
				reject(error)
			}
		})
	})
}


//判断对象是否相等
function isObjectValueEqual(a, b) {
	var aProps = Object.getOwnPropertyNames(a);
	var bProps = Object.getOwnPropertyNames(b);
	if (aProps.length != bProps.length) {
		return false;
	}
	for (var i = 0; i < aProps.length; i++) {
		var propName = aProps[i];
		if (a[propName] !== b[propName]) {
			return false;
		}
	}
	return true;
}
// 请求回调
var httpReback = function() {
	uni.removeStorageSync('token');
	uni.removeStorageSync('info');
	uni.removeStorageSync('sm4Key');
	uni.removeStorageSync('mode')
	uni.showToast({
		title: '登录过期',
		icon: 'error',
		success() {
			uni.reLaunch({
				url: '../../page_class/login/index'
			})
		}
	})
}
// 获取请求头
var getHead = function(res) {
	//#ifdef APP-PLUS
	return JSON.parse(res.header['ZY-Head']).retArray[0]
	//#endif
	//#ifdef H5
	return JSON.parse(res.header['zy-head']).retArray[0]
	//#endif
	//#ifdef MP-WEIXIN
	return JSON.parse(res.header['ZY-Head']).retArray[0]
	//#endif
}
//封装请求
let request = function(config) {
	let api = {}
	var prev;
	var time;
	var prevData;
	var EncryptData;
	config.forEach(item => {
		api[item.name] = (data = null) => {
			return new Promise(async (resolve, reject) => {
				if (prev == item.name) {
					if (new Date().getTime() - time < 1000) {
						if (data != null) {
							if (isObjectValueEqual(data, prevData)) {
								uni.hideLoading();
								return false;
							}
						}
					}
				}
				time = new Date().getTime()
				prev = item.name
				prevData = data
				if (uni.getStorageSync('sm4Key')) {
					var sm4Key = uni.getStorageSync('sm4Key');
				}

				// mode请求失败重新请求
				if (!mode) {
					let modeGet = await getMode()
				}

				// 第二次判断 根据mode判断是否加密
				if (mode) {
					if (data != null && mode.encryptIgnoreUrl.indexOf(item.url) == '-1' &&
						mode.msgBodyEncrypt == 'true') {
						var EncryptData = sm4Fun.sm4Encrypt(JSON.stringify(data), sm4Key)
					} else {
						var EncryptData = data
					}
				} else {
					var EncryptData = data
				}

				var header = {
					'content-type': 'application/json',
					'terminalFP': hmacKeyA
				}

				if (item.url != 'user/stdlogin') {
					if (Vue.prototype.$store.state.moduleMain.token != null && 
					Vue.prototype.$store.state.moduleMain.token != '') {
						header.UserAuthorization = uni.getStorageSync('token')
					}
				}


				uni.request({
					method: item.methods,
					url: Vue.prototype.$store.state.moduleMain.url + item.url,
					header,
					data: EncryptData,
					success: (res) => {
						let retArray = getHead(res)
						if (retArray.retCode == 'T99208' || retArray.retCode ==
							'T99203') {
							httpReback()
						} else {
							if (mode.encryptIgnoreUrl.indexOf(item.url) ==
								'-1' && mode.msgBodyEncrypt == 'true') {
								var dRes = JSON.parse(sm4Fun.sm4Decrypt(res
									.data, sm4Key))
								resolve(dRes)
							} else {
								var dRes = res.data
								resolve(dRes)
							}
						}
					},
					fail(error) {
						reject(error)
					},
					complete(data) {
						if (data.statusCode == '403') {
							httpReback()
						}
					}
				})
			})
		}
	})
	return api
}
export default function() {
	return request(configData)
}
